package com.docus.soap.api;

import org.springframework.ws.client.core.WebServiceTemplate;

public class SoapAPIClient {
    private WebServiceTemplate webServiceTemplate;
    private SoapAPIMessageGenerator messageGenerator;
    private SoapAPIResponseExtractor responseExtractor;

    public Object soapCall(Object requestBody, String soapAction, String uri) {
        SoapMessageEnvelope messageEnvelope = new SoapMessageEnvelope();
        messageEnvelope.setSoapBody(requestBody);
        messageEnvelope.setSoapAction(soapAction);
        webServiceTemplate.setDefaultUri(uri);
        return webServiceTemplate.sendAndReceive(messageGenerator.generateSoapMessage(messageEnvelope), responseExtractor.generateExtractor());
    }

    public void setWebServiceTemplate(WebServiceTemplate webServiceTemplate) {
        this.webServiceTemplate = webServiceTemplate;
    }

    public void setMessageGenerator(SoapAPIMessageGenerator messageGenerator) {
        this.messageGenerator = messageGenerator;
    }

    public void setResponseExtractor(SoapAPIResponseExtractor responseExtractor) {
        this.responseExtractor = responseExtractor;
    }
}
