package com.docus.soap.api;

import com.docus.soap.api.util.XmlUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.ws.WebServiceMessage;
import org.springframework.ws.client.WebServiceClientException;
import org.springframework.ws.client.support.interceptor.ClientInterceptor;
import org.springframework.ws.context.MessageContext;
import org.springframework.ws.soap.SoapMessage;

public class SoapAPILogIntercepter implements ClientInterceptor {

    private static Logger logger = LoggerFactory.getLogger(SoapAPILogIntercepter.class);

    @Override
    public boolean handleRequest(MessageContext messageContext) throws WebServiceClientException {
        WebServiceMessage request = messageContext.getRequest();
        SoapMessage soapMessage = (SoapMessage) request;
        logger.debug("soap-action:{}", soapMessage.getSoapAction());
        logger.debug("soap-request:\n{}", XmlUtils.pretty(soapMessage.getDocument()));
        return true;
    }

    @Override
    public boolean handleResponse(MessageContext messageContext) throws WebServiceClientException {
        return true;
    }

    @Override
    public boolean handleFault(MessageContext messageContext) throws WebServiceClientException {
        return true;
    }

    @Override
    public void afterCompletion(MessageContext messageContext, Exception ex) throws WebServiceClientException {
        WebServiceMessage request = messageContext.getResponse();
        SoapMessage soapMessage = (SoapMessage) request;
        logger.debug("response:\n{}", XmlUtils.pretty(soapMessage.getDocument()));
    }
}
