package com.docus.soap.api;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.oxm.Unmarshaller;
import org.springframework.ws.WebServiceMessage;
import org.springframework.ws.client.core.WebServiceMessageExtractor;
import org.springframework.ws.soap.SoapFault;
import org.springframework.ws.soap.SoapMessage;
import org.springframework.ws.support.MarshallingUtils;

import javax.xml.transform.TransformerException;
import java.io.IOException;

public class SoapAPIResponseExtractor {

    private static Logger logger = LoggerFactory.getLogger(SoapAPIResponseExtractor.class);
    private Unmarshaller unmarshaller;

    public WebServiceMessageExtractor generateExtractor() {
        return new WebServiceMessageExtractor() {
            @Override
            public Object extractData(WebServiceMessage message) throws IOException, TransformerException {
                SoapMessage soapMessage = (SoapMessage) message;
                SoapFault fault = soapMessage.getSoapBody().getFault();
                if (null != fault) {
                    logger.info("{}", fault.getFaultStringOrReason());
                } else {
                    return MarshallingUtils.unmarshal(unmarshaller, message);
                }
                return null;
            }
        };
    }

    public void setUnmarshaller(Unmarshaller unmarshaller) {
        this.unmarshaller = unmarshaller;
    }
}
