package com.docus.soap.api.service;

import com.docus.soap.api.SoapAPIClient;
import com.docus.soap.api.SoapAPISettings;
import com.docus.soap.api.request.zsyy.GetLoginInfoRequest;
import com.docus.soap.api.request.zsyy.GetQRCodeBySysRequest;
import com.docus.soap.api.request.zsyy.GetQueryQRCodeRequest;
import com.docus.soap.api.response.zsyy.*;
import com.docus.soap.api.util.JSON;
import com.sun.org.apache.xerces.internal.dom.ElementNSImpl;

public class XMZSYYQRCodeAPIService {
    private SoapAPIClient soapAPIClient;

    /**
     * 中山医院获取二维码
     */
    public GetQRCodeBySysResponse getQRCodeBySys(GetQRCodeBySysRequest targetRequest, SoapAPISettings soapAPISettings) {
        GetQRCodeBySysResultResponse response = (GetQRCodeBySysResultResponse) soapAPIClient.soapCall(targetRequest, soapAPISettings.getAction(), soapAPISettings.getUri());
        return JSON.fromJSON((((ElementNSImpl) response.getResults().get(0)).getFirstChild().getTextContent()), GetQRCodeBySysResponse.class);
    }
    /**
     * @description: 中山医院获取扫码状态
     * @author linjj
     * @date: 2023/5/24 11:46
     */
    public GetQueryQRCodeResponse getQueryQRCode(GetQueryQRCodeRequest queryQRCodeRequest, SoapAPISettings soapAPISettings){
        GetQueryQRCodeResultResponse response = (GetQueryQRCodeResultResponse) soapAPIClient.soapCall(queryQRCodeRequest, soapAPISettings.getAction(), soapAPISettings.getUri());
        return JSON.fromJSON((((ElementNSImpl) response.getResults().get(0)).getFirstChild().getTextContent()), GetQueryQRCodeResponse.class);
    }
    /**
     * @description: 厦门中山医院单点登录
     * @author linjj
     * @date: 2023/5/25 11:33
     */
    public GetLoginInfoResponse getLoginInfo(GetLoginInfoRequest getLoginInfoRequest, SoapAPISettings soapAPISettings){
        GetLoginInfoResultResponse response = (GetLoginInfoResultResponse) soapAPIClient.soapCall(getLoginInfoRequest, soapAPISettings.getAction(), soapAPISettings.getUri());
        return JSON.fromJSON((((ElementNSImpl) response.getResults().get(0)).getFirstChild().getTextContent()), GetLoginInfoResponse.class);
    }
    public void setWebServiceClient(SoapAPIClient webServiceClient) {
        this.soapAPIClient = webServiceClient;
    }


}
