package com.docus.soap.api.util;

import com.fasterxml.jackson.databind.AnnotationIntrospector;
import com.fasterxml.jackson.databind.introspect.JacksonAnnotationIntrospector;
import com.fasterxml.jackson.databind.type.TypeFactory;
import com.fasterxml.jackson.module.jaxb.JaxbAnnotationIntrospector;

public final class NullObjectMapperBuilder {

    private final ObjectMapperBuilder builder;

    private NullObjectMapperBuilder() {
        this.builder = ObjectMapperBuilder.defaultObjectMapper();
        AnnotationIntrospector primary = new JacksonAnnotationIntrospector();
        AnnotationIntrospector secondary = new JaxbAnnotationIntrospector(TypeFactory.defaultInstance());
        this.builder.get().setAnnotationIntrospector(AnnotationIntrospector.pair(primary, secondary));
        this.builder.get().getSerializerProvider().setNullValueSerializer(NullSerializer.INSTANCE);
    }

    private static final NullObjectMapperBuilder INSTANCE = new NullObjectMapperBuilder();

    public static ObjectMapperBuilder get() {
        return INSTANCE.builder;
    }
}
