package com.docus.soap.api.util;

import javax.xml.bind.annotation.adapters.XmlAdapter;
import java.util.Date;

public class StringDateTimeAdapter extends XmlAdapter<String, Date> {

    private static final String SIMPLE_ISO_FORMAT = "yyyy-MM-dd'T'HH:mm:ss";
    private static final String DATE_FORMAT_ISO_WITHOUT_TIMEZONE = "yyyy-MM-dd'T'HH:mm:ss.SSS";

    @Override
    public Date unmarshal(String v) throws Exception {
        if (!StringUtils.hasText(v)) {
            return null;
        }
        if (v.length() > SIMPLE_ISO_FORMAT.length()) {
            return Convert.toDate(v, DATE_FORMAT_ISO_WITHOUT_TIMEZONE, null);
        } else {
            return Convert.toDate(v, SIMPLE_ISO_FORMAT, null);
        }
    }

    @Override
    public String marshal(Date v) throws Exception {
        if (v == null) {
            return null;
        }
        return Convert.toString(v, SIMPLE_ISO_FORMAT);
    }

}
